<template>
	<Background>
		<CardLayout>
			<template slot="head">
				<CommonHeader :title="$t('comments').toUpperCase()"></CommonHeader>
			</template>
			<template slot="top">
				<div class="product-image" :style="imageCSS">
					<div class="mask"></div>
				</div>
			</template>
			<template slot="body">
				<div v-if="product" class="info">
					<div class="title-bar">
						<span>{{localizedProductName(product).toUpperCase()}}</span>
						<div class="likes">
							<LikeButton class="like" :selected="true"></LikeButton>
							<span>{{product.goodReviews}}</span>
							<LikeButton class="like" :selected="true" :positive="false"></LikeButton>
							<span>{{product.badReviews}}</span>
							<CommentsButton :long="false"></CommentsButton>
							<span>{{product.totalReviews}}</span>
						</div>
					</div>
					<p>{{localizedProductDescription(product)}}</p>

					<div class="tabs">
						<div
							class="tab"
							:class="{active: selected == 'all'}"
							:style="selected == 'all'? borderColorCSS : ''"
							@click="selected = 'all'"
						>{{$t('all')}}</div>
						<div
							class="tab"
							:class="{active: selected == 'positives'}"
							:style="selected == 'positives'? borderColorCSS : ''"
							@click="selected = 'positives'"
						>{{$t('positives')}}</div>
						<div
							class="tab"
							:class="{active: selected == 'negatives'}"
							:style="selected == 'negatives'? borderColorCSS : ''"
							@click="selected = 'negatives'"
						>{{$t('negatives')}}</div>
					</div>
					<div class="reviews-section">
						<SpinnerHolder v-if="loading"></SpinnerHolder>
						<div v-else v-for="(review,index) of reviews" :key="index" class="review">
							<div class="title">
								<span class="name">{{review.name.toUpperCase()}}</span>
								<span class="date">{{formatDate(review.createdAt)}}</span>
							</div>
							<span class="content">{{review.content}}</span>
						</div>
					</div>
					<div class="input">
						<input
							v-if="!userCommented"
							inputmode
							type="text"
							v-model.trim="formData.text"
							v-on:keyup.enter="showForm()"
							:placeholder="$t('leave a comment')"
						/>
						<Next v-if="!userCommented" class="send-button" @click="showForm()" size="30px"></Next>
						<span v-else>{{$t('thank you comment')}}</span>
					</div>
				</div>
				<div v-else>
					<h1>Platillo no encontrado</h1>
				</div>
				<MiniCart></MiniCart>
			</template>
		</CardLayout>

		<Modal v-if="modalForm" @close="hideForm()">
			<div v-if="!userCommented" class="send-form">
				<div class="form-group">
					<span class="label">{{ $t('name') }}:</span>
					<input
						name="fname"
						type="text"
						class="form-control bee-input"
						v-model.trim="formData.name"
						:placeholder="$t('johnDoe') "
					/>
					<span v-if="formErrors.name" class="error">{{ $t('nameError') }}</span>
				</div>
					<span class="label">{{ $t('wouldRecommend?') }}</span>
				<div class="form-group like-options">
					<LikeButton class="like" @click="formData.positive = true" :selected="formData.positive"></LikeButton>
					<LikeButton
						class="like"
						@click="formData.positive = false"
						:selected="!formData.positive"
						:positive="false"
					></LikeButton>
				</div>
				<div class="form-group">
					<AjaxButton class="final-button" :loading="loading" :text="$t('send')" @click="sendForm()"></AjaxButton>
					<span v-if="ajaxError" class="error">{{ $t('ajaxError') }}</span>
				</div>
				<div class="form-group" style="font-size: 10px;">
					This site is protected by reCAPTCHA and the Google
					<a
						href="https://policies.google.com/privacy"
					>Privacy Policy</a> and
					<a href="https://policies.google.com/terms">Terms of Service</a> apply.
				</div>
			</div>
			<div v-else class="good-ending" @click="hideForm()">
				<div style="text-align:center">
					<h3>{{$t('thank you comment')}}</h3>
				</div>
			</div>
		</Modal>
	</Background>
</template>

<script lang="ts">
import { Component, Watch, Vue } from 'vue-property-decorator'
import CardLayout from '@/layouts/CardLayout.vue'
import Background from '@/components/Background.vue'
import Next from '@/components/Next.vue'
import CounterButton from '@/components/CounterButton.vue'
import SpinnerHolder from '@/components/SpinnerHolder.vue'
import Product from '@/models/Product'
import CommonHeader from '@/components/CommonHeader.vue'
import BeeCheckbox from '@/components/BeeCheckbox.vue'
import MiniCart from '@/components/MiniCart.vue'
import Modal from '@/components/Modal.vue'
import CommentsButton from '@/components/CommentsButton.vue'
import LikeButton from '@/components/LikeButton.vue'
import AjaxButton from '@/components/AjaxButton.vue'
import Review from '../models/Review'
import {User} from '../models/User'
import MenuService from '../services/MenuService'

@Component({
	components: {
		Background,
		CardLayout,
		CommonHeader,
		Next,
		CounterButton,
		SpinnerHolder,
		BeeCheckbox,
		Modal,
		MiniCart,
		CommentsButton,
		LikeButton,
		AjaxButton
	}
})
export default class Reviews extends Vue {
	product: Product | null = null
	selected = 'all'
	userCommented = false
	user: User | null = this.$store.state.user
	reviews: Review[] = []
	barColor = this.$store.getters.colors.backgroundColor
	loading = false
	modalForm = false
	formData = {
		name: '',
		text: '',
		positive: true
	}
	formErrors = { name: false, text: false, valid: false }
	ajaxError = false

	@Watch('selected')
	async onSelectedChanged(newSelection: string) {
		if (this.product) {
			this.loading = true
			this.reviews = await MenuService.getReviewsOfProduct(this.product.id, newSelection)
			this.reviews = this.reviews.sort((c, n) => c.createdAt.getTime() - n.createdAt.getTime())
			this.loading = false
		}
	}

	showForm() {
		const text = this.formData.text.trimStart()
		if (this.userCommented === false && text.length > 1) {
			this.modalForm = true
		}
	}

	async sendForm() {
		if (!this.validForm()) return
		if (!this.product) return
		if (!this.user) return

		this.loading = true

		const newReview = new Review(this.user.id)
		newReview.content = this.formData.text
		newReview.language = this.$store.state.language
		newReview.name = this.formData.name
		newReview.createdAt = new Date()
		newReview.positive = this.formData.positive

		let token = ''
		if (process.env.NODE_ENV == 'production') {
			await this.$recaptchaLoaded()
			token = await this.$recaptcha('sendOrder')
		}
		const result = await MenuService.sendReview(this.product.id, newReview, token)

		if (result) {
			this.userCommented = true
		} else {
			this.ajaxError = true
		}
		this.loading = false
	}

	hideForm() {
		this.modalForm = false
	}

	validForm(): boolean {
		this.formErrors = { name: false, text: false, valid: false }

		if (!this.formData.name) {
			this.formErrors.name = true
		}

		for (const error of Object.values(this.formErrors)) {
			if (error == true) {
				return false
			}
		}
		return true
	}

	getProduct(productId: string) {
		const products = this.$store.getters.products as Product[]
		const product = products.find(p => p.id == productId)

		return product || null
	}

	formatDate(d: Date) {
		//return `${d.getDay()}/${d.getMonth()}/${d.getFullYear()} : ${d.getHours()}:${d.getMinutes()}`
		return d.toLocaleDateString()
	}

	goBack() {
		history.back()
	}

	get imageCSS() {
		if (this.product && this.product.photosURL) return `background-image: url('${this.product.photosURL[0]}'`
		return ''
	}

	get borderColorCSS() {
		return `border-bottom-color: ${this.barColor};`
	}

	async created() {
		this.product = this.getProduct(this.$route.params.productId)
		if (this.product && this.user) {
			this.userCommented = await MenuService.userCommentedProduct(this.product.id, this.user.id)
		}
	}

	async mounted() {
		if (this.product) {
			this.loading = true
			this.reviews = await MenuService.getReviewsOfProduct(this.product.id, this.selected)
			this.reviews = this.reviews.sort((c, n) => c.createdAt.getTime() - n.createdAt.getTime())
			this.loading = false
		}
	}
}
</script>

<style lang="scss" scoped>
.product-image {
	width: 100%;
	height: 100%;
	background-size: 130%;
	background-repeat: no-repeat;
	background-position: center;
	position: relative;
	display: flex;
	background-image: url('~@/assets/icons/bee-blanco.svg');
	background-size: contain;

	.mask {
		width: 100%;
		height: 20%;
		background-color: rgba($color: #000000, $alpha: 1);
		mask-image: linear-gradient(rgba(0, 0, 0, 1), transparent);
	}
}

.info {
	display: flex;
	flex-direction: column;
	justify-content: flex-start;
	min-height: 90%;

	.title-bar {
		padding: 10px;
		display: flex;
		justify-content: space-between;
		align-items: center;
		span {
			font-weight: bold;
			font-size: 20px;
		}
	}
	p {
		padding: 10px;
	}

	.likes {
		display: flex;
		font-family: 'Roboto Condensed';
		align-items: center;
		span {
			font-weight: lighter;
			font-size: 10px;
			margin-right: 10px;
		}
	}

	.tabs {
		display: flex;
		border-bottom: 1px solid #b3b6b8;
		justify-content: space-evenly;
		font-size: 10px;
		font-weight: bolder;

		.tab {
			width: 33%;
			justify-content: center;
			height: 40px;
			align-items: center;
			display: flex;
			user-select: none;
		}

		.active {
			border-bottom: 4px solid yellow;
		}
	}

	.reviews-section {
		width: 100%;
		height: 260px;
		font-family: 'Roboto Condensed';
		overflow-y: auto;
		scrollbar-color: gray black;
		.review {
			padding: 15px 20px;
			.title {
				display: flex;
				justify-content: flex-start;
				align-items: baseline;
				.name {
					font-size: 15px;
					font-weight: bolder;
					margin-right: 10px;
				}

				.date {
					font-size: 8px;
				}
			}
			.content {
				font-size: 13px;
				color: #b3b6b8;
				word-break: break-all;
				word-wrap: normal;
			}
		}
	}

	.input {
		margin: auto;
		position: relative;

		input {
			border: 1px solid #b3b6b8;
			border-radius: 50px;
			width: 330px;
			height: 30px;
			padding: 2px 10px;
		}

		input:focus {
			outline: none;
		}

		.send-button {
			position: absolute;
			right: 5px;
			top: 3px;
		}
	}
}

.send-form {
	color: black;
	font-family: 'Roboto Condensed';

	.like-options {
		display: flex;
		justify-content: space-around;

		.like {
			width: 30px;
			height: 30px;
		}
	}
	.form-group {
		margin: 10px 0px;
	}
	.error {
		font-size: 12px;
		color: red;
		margin: auto;
	}
	.bee-input,
	.bee-button {
		width: 300px;
	}
	.bee-input {
		padding: 0;
		font-size: 15px;
	}

	.final-button {
		margin-top: 15px;
	}
}
</style>
